import processing.core.*; 
import processing.xml.*; 

import processing.serial.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class lab3RadarProcessingSketch extends PApplet {

/* lab3 radar
 
 * 
 * visualize data from ultrasonic distance sensor
 *
 
 */

// import serial library


// serial port
Serial port;

// Serial variables
String serialString;
String rxString = null; // Anwort vom Ser Port
int cr = 13; // carriage return
int lf = 10; // line feed

// distance
int distance;

// current angle
int currentAngle;

// this block is executed one time when programm starts
public void setup(){

  // size of window
  size(800,600);

  // print a list of the serial ports, to get port of arduino port
  println("Serial ports");
  println(Serial.list());

  // init serial port, on my computer the arduino port is the first port
  port = new Serial(this, Serial.list()[0], 9600);
  
  frameRate(24);
  background(0);

}

// this block is executed in a loop after setup is called one time
public void draw(){

  // clear background
  fill(0,1);
  rect(0,0,width,height);

  // translate
  translate(width/2, height/2);
  
  // use current 
  rotate(radians((currentAngle/96.0f)*360.0f));
  
  // draw line
  stroke(255);
  
  line(0,0,distance/1.5f,0);

}

// serial event
public void serialEvent(Serial p){

  // get string till line break (ASCII > 13) 
  serialString = port.readStringUntil(13);
  // just if there is data
  if (serialString != null) {
    // try catch function because of possible garbage in received data
    try {
      String[] test = splitTokens(serialString);
      // get current angle
      currentAngle = Integer.parseInt(test[0]);
      // get distance
      distance = Integer.parseInt(test[1]);
    }
    catch (Exception e){
    }
  }
}








  static public void main(String args[]) {
    PApplet.main(new String[] { "--present", "--bgcolor=#666666", "--stop-color=#cccccc", "lab3RadarProcessingSketch" });
  }
}
