/* lab3 radar
 
 * 
 * visualize data from ultrasonic distance sensor
 *
 
 */

// import serial library
import processing.serial.*;

// serial port
Serial port;

// Serial variables
String serialString;
String rxString = null; // Anwort vom Ser Port
int cr = 13; // carriage return
int lf = 10; // line feed

// distance
int distance;

// current angle
int currentAngle;

// this block is executed one time when programm starts
void setup(){

  // size of window
  size(800,600);

  // print a list of the serial ports, to get port of arduino port
  println("Serial ports");
  println(Serial.list());

  // init serial port, on my computer the arduino port is the first port
  port = new Serial(this, Serial.list()[0], 9600);
  
  frameRate(24);
  background(0);

}

// this block is executed in a loop after setup is called one time
void draw(){

  // clear background
  fill(0,1);
  rect(0,0,width,height);

  // translate
  translate(width/2, height/2);
  
  // use current 
  rotate(radians((currentAngle/96.0)*360.0));
  
  // draw line
  stroke(255);
  
  line(0,0,distance/1.5,0);

}

// serial event
void serialEvent(Serial p){

  // get string till line break (ASCII > 13) 
  serialString = port.readStringUntil(13);
  // just if there is data
  if (serialString != null) {
    // try catch function because of possible garbage in received data
    try {
      String[] test = splitTokens(serialString);
      // get current angle
      currentAngle = Integer.parseInt(test[0]);
      // get distance
      distance = Integer.parseInt(test[1]);
    }
    catch (Exception e){
    }
  }
}







